from mini.track.placeable import PlaceableModel
from world import World

def desert_games_loaded_count():
	count = 0
	if World.CLICK.hasBeenLoaded():
		count += 1
	if World.LEGS.hasBeenLoaded():
		count += 1
	if World.SHEPHERD.hasBeenLoaded():
		count += 1
	if World.BORING.hasBeenLoaded():
		count += 1
	if World.ISLAND.hasBeenLoaded():
		count += 1
	if World.GRAVEYARD.hasBeenLoaded():
		count += 1
	return count

def shouldRun():
	return desert_games_loaded_count() >= 2
	
def run(ctx):
	create_arch(ctx)
	ctx.sleep(5)#
	destroy_construction(ctx)
	ctx.sleep(60)#
	create_pacman(ctx)
	ctx.sleep(30)#
	create_breakout(ctx)
	ctx.sleep(30)#
	
def destroy_construction(ctx):
	ctx.destroy(world["EggworldConstructionGroup"])

def create_arch(ctx):
	ctx.camera.lookAt(world["EggworldArchShotFrom"], world["EggworldArchShotTo"])#
	ctx.sleep(30)#
	ctx.create(world["EggworldArch"])
	
def look_at_pacman(ctx, frames):
	ctx.move(ctx.camera.eye).to(world["PacmanFrontFrom"]).over(frames)
	return ctx.move(ctx.camera.center).to(world["PacmanFrontTo"]).over(frames)
	
def create_pacman(ctx):
	look_at_pacman(ctx, 30).await()#
	ctx.sleep(15)#
	ctx.create(get_creatable_pacman_objects())
	ctx.sleep(15)#
	ctx.create(world["PacmanEntrance"])
	
def create_breakout(ctx):
	ctx.move(ctx.camera.center).to(world["BreakoutLookat"]).over(30).await()#
	ctx.create(world["BreakoutGroup"])


	
def is_creatable_for_pacman(entity):
	return isinstance(entity, PlaceableModel)
	
def get_creatable_pacman_objects():
	return [e for e in world["PacmanCreateSection"] if is_creatable_for_pacman(e)]