from mini.track.placeable import PlaceableModel
from loc.graveyard import GraveyardSpawner

def should_create_flowers():
	return GraveyardSpawner.forgiven.isAwarded()

def is_flower(entity):
	if isinstance(entity, PlaceableModel):
		if entity.modelName == "tulip crude.obj":
			return True
	return False
	
def get_flower_objects():
	return [e for e in world["GraveyardGroup"] if is_flower(e)]
	
def get_non_flower_objects():
	return [e for e in world["GraveyardGroup"] if not is_flower(e)]
	
if not should_create_flowers():
	for e in get_flower_objects():
		e.destroy()
	