from mini.track import TrackSpawner
from mini.track.dialog import Message
from mini.track.dialog import Speaker            

from audio import Audio

from owg.util.opengl import ColorF

from mini.track.util.V3DConverter import convertToV3D
from loc.dmv import DMVSpawner

s = SimpleNamespace()
s.going = False
speaker = Speaker(convertToV3D(world["PigFace"]).asV3F().add(0, 0, -1), ColorF("#FF99D3"), "Cop")

def speak(text, life_in_frames):
	Audio.play("oink", None, 0.8, None, 1)
	message = Message(speaker, text, life_in_frames)
	game.dialogDisplay.showMessage(message)

def onEnter():
	if TrackSpawner.copAcknowledgedDriversLicense.isPresent():
		speak("#FF0000License## checks out, plates look fine, etc. Your free to go.", 150)
	elif not DMVSpawner.license.isAwarded():
		speak("#FF0000License## and registration, please.", 150)
	elif not s.going:
		enqueue_cutscene(script)
		s.going = True

def message(text, steps):
	return Message(speaker, text, steps)

def script(ctx):
	ctx.camera.lookAt(world["PigFromAnchor"], world["PigToAnchor"])
	ctx.sleep(15)
	Audio.play("oink", None, 0.8, None, 1)
	ctx.show(message("...Everything checks out. Your free to go.", 90)).await()
	TrackSpawner.copAcknowledgedDriversLicense.add()
	
def onLeave():
	pass