from mini.track import TrackSpawner
from mini.track.dialog import Message
from mini.track.dialog import Speaker           

from audio import Audio

from owg.util.opengl import ColorF

from mini.track.util.V3DConverter import convertToV3D
from mini.track.util.RainbowTextProcessor import process

s = SimpleNamespace()
s.going = False
s.first_message = False
medal_bastard_model = world["MedalBastardModel"]
speaker = Speaker(convertToV3D(medal_bastard_model).asV3F().add(0, 0, 3.33), ColorF("#EC6971"), "Medal Bastard")

def speak(text, life_in_frames):
	Audio.play("medal bastard talk", None, 0.8, None, 1)
	message = Message(speaker, text, life_in_frames)
	game.dialogDisplay.showMessage(message)
	return message

def onEnter():
	if TrackSpawner.medalBastardAcknowledgedMedals.isPresent():
		if s.first_message:
			maniac = process("maniac")
			speak("I'm a " + maniac + " when it comes to medals. I would love to have a collection like yours...", 240)
		else:
			speak("Have fun in #FF0000Downtown Mundenmark##!", 90)

		s.first_message = not s.first_message
	elif game.awardedHalfMedalValue < 14:
		speak("Hey kid! Don't you know? You need #FF00007 medals## to get beyond from here!", 210)
	elif not s.going:
		enqueue_cutscene(script)
		s.going = True

def script(ctx):
	cameraFrom = v3d(medal_bastard_model).add(v3d(game.player).sub(v3d(medal_bastard_model)).multiply(6)).z(15)
	ctx.camera.lookAt(cameraFrom, medal_bastard_model)
	ctx.sleep(15)
	ctx.show(speak("Wow you got all #FF0000750 medals## that I wanted to see! Welcome to Down Town.", 90)).await()
	TrackSpawner.medalBastardAcknowledgedMedals.add()
	
def onLeave():
	pass