from audio import Audio
from mini.track.util.V3DConverter import convertToV3D

from mini.track import TrackSpawner
from mini.track.dialog import Message
from mini.track.dialog import Speaker
from owg.util.opengl import ColorF
from owg.util.Calc import choose

s = SimpleNamespace()
s.going = False
prince_worm_model = world["PrinceWormModel"]
speaker = Speaker(convertToV3D(prince_worm_model).asV3F().add(0, 0, 1.5), ColorF("#9898FF"), "Prince Worm")

def speak(text, life_in_frames):
	Audio.play("prince worm speak", None, 1, None, 1)
	message = Message(speaker, text, life_in_frames)
	game.dialogDisplay.showMessage(message)
	return message

def onEnter():
	if TrackSpawner.wormPrinceAcknowledgedMedals.isPresent():
		speak(choose("Hey what's up?", "I'm the prince of the Worms.", "What's going on?"), 60)
	elif game.awardedHalfMedalValue < 60:
		speak("I am the prince of the Worms. I am here to keep #888888Bogus## out. However, if you show me #FF000030 medals##, I might let you in.", 210)
	elif not s.going:
		enqueue_cutscene(script)
		s.going = True

def script(ctx):
	game.player.setVisible(False)
	ctx.camera.lookAt(world["PrinceWormFrom"], v3d(prince_worm_model).add(0, 0, 1))
	ctx.sleep(15)
	ctx.show(speak("Impressive medal collection! I guess I can let you into the #247054Wasteland##.", 100)).await()
	TrackSpawner.wormPrinceAcknowledgedMedals.add()
	
def onLeave():
	pass