from mini.track import TrackSpawner
from mini.track.util import FunctionalEntity
from owg.util import Calc
from audio import Audio

s = SimpleNamespace()

def onEnter():
    if TrackSpawner.spilledPogoTrashcan.isPresent():
        return

    spill_trashcan()

def onLeave():
    pass

s.scene_enqueued = False

def spill_trashcan():
    if s.scene_enqueued:
        return

    Audio.play("spill trash can", None, 1, None, 1)
    start_twirling(world["TrashCan"])
    s.scene_enqueued = True
    enqueue_cutscene(script)

def script(ctx):
    ctx.camera.lookAt(world["TrashFrom"], world["TrashTo"])
    game.player.angle = Calc.PI / 2
    game.player.speed.multiply(0)
    game.player.pos.set(world["TrashCanPutPlayer"].pos.asV2D())
    ctx.sleep(30)
    TrackSpawner.spilledPogoTrashcan.add()

def start_twirling(model):
    s.rate = 1
    s.step = 0
    clip = Audio.getClip("wobble trash can")
    clip.setLooping(True)
    clip.setPosition(None, 0.95)
    clip.setSpeed(None, 1)
    clip.play()

    def do_twirl():
        if model.isDestroyed():
            clip.stop()
            return False

        s.step += s.rate
        model.setAngle(model.getAngle() + 0.1 * s.rate)
        stupid = 0.3 + (1 - s.rate) * 0.2
        model.xAngle = Calc.fastSin(s.step * 0.3) * stupid
        s.rate = max(0.1, s.rate - 0.01)
        clip.setSpeed(None, s.rate)
        return True

    FunctionalEntity.stepWhile(game.list(), do_twirl)