from mini.track.placeable import PlaceableModel
from audio import Audio
from world import World

tulips = [x for x in world["TulipsGroup"] if isinstance(x, PlaceableModel) and x.modelName == "tulip buds.obj"]

def shouldRun():
    return World.DRUM.hasBeenLoaded()

def bloom_tulips(ctx):
    for t in tulips:
        Audio.play("tulip bloom", None, 1, None, 1)#
        if not ctx.isInverse():
            t.modelName = "tulip blooms.obj"
        ctx.sleep(5)#

def run(ctx):
    entrance = world["TulipsEntrance"]
    ctx.camera.lookAt(world["TulipsFrom"], v3d(entrance).z(4))#
    ctx.sleep(30)#
    bloom_tulips(ctx)
    ctx.sleep(15)#
    ctx.create(entrance)
    ctx.sleep(15)#