from owg.util import Calc
from mini.track.PlayState import Screen

base_angles = {}

wizard = world["BoringWizard"]
wizard_initial_angle = wizard.getAngle()

for t in world["BoringTexts"]:
	base_angles[t] = t.yAngle

def step():
	angle_to_player = Calc.dir(wizard.getX(), wizard.getY(), game.player.pos.x(), game.player.pos.y()) - Calc.PI / 2
	if should_rotate_wizard():
		wizard.setAngle(Calc.approachAngleLin(wizard.getAngle(), angle_to_player, 0.025), False)
	else:
		wizard.setAngle(wizard_initial_angle, False)
	
	for t in world["BoringTexts"]:
		t.yAngle = base_angles[t] + Calc.random() * 0.05 - 0.025
		f = Calc.fastSin(float(game.sixtystage) / 30.0 * Calc.PI + t.x)
		t.z += f * 0.1
		
def should_rotate_wizard():
	return not game.currentScreen() == Screen.CUTSCENE